<?php

//---------------------------------------------------
// RSS Parser/Creator
// Script created 19 Apr 2004 by tanguy at pruvot.org
//---------------------------------------------------

include("inc/browseremulator.class.php");
include("inc/rss_tools.inc.php");
include("inc/ini.class.php");

define("XML_FILE","parsimony.xml");

define("PAGE_TITLE", "Windev Forum on Parsimony");
define("PAGE_DESC",  "Windev Forum messages");
define("PAGE_URL",   "http://f16.parsimony.net/forum28986/recent.htm");
define("PAGE_LANG",  "en");

define("PAGE_CACHE",  900);

define("PAGE_START", '<ul>');
define("PAGE_STOP",  '</ul>');

define("BLOC_START",'<li>');
define("BLOC_STOP",'</i>');

define("PAGE_DIR", substr(PAGE_URL,0,strrpos(PAGE_URL,"/")+1));

$ini_section = substr(XML_FILE,0,strpos(XML_FILE,"."));
IniIncrementValue($ini_section,"ACCESSED","stats.ini");

//#####################################################################
//WGET

$be = new BrowserEmulator();
$be->addHeaderLine("Referer", PAGE_URL);
$be->addHeaderLine("Accept-Encoding", "x-compress; x-zip");

$file = $be->fopen(PAGE_URL);
$response = $be->getLastResponseHeaders();

if (!(strpos($response[0],"200"))) die("error! can't connect to site :".$response[0]);

$html_data = "";
while ($line = fgets($file, 1024)) {
	$html_data .= $line;
}
fclose($file);

//#####################################################################

$html_data = strstr($html_data, PAGE_START);
$html_data = substr($html_data, 0, strlen($html_data)-strlen( strstr($html_data,PAGE_STOP) ));
$html_data = trim_br(str_replace("\n","",$html_data));

if ($html_data) {

	include("inc/feedcreator.class.php");

	//-----------------------------------------------------------------
	function restore_urls($matches,$base_url=PAGE_DIR) {
		return $matches[1].assemble_url($base_url,$matches[2]).$matches[3];
	}

	function cell_content_to_item($content_html, $date="", $category="", $title="", $author="", $base_url=PAGE_DIR) {

		$rss_item = new FeedItem();

		$rss_item->date = $date;

		if (preg_match_all('|<a href="([^"]*)"[^>]*>(.*?)</a>(.*)|is', $content_html, $sub_matches)) {
			$rss_item->link        = assemble_url($base_url,$sub_matches[1][0]);
			$rss_item->title       = $sub_matches[2][0];
			$rss_item->description = $sub_matches[0][0];
		} else {
			$rss_item->title = substr($content_html,0,strlen($content_html)-strlen( strstr($content_html,"\n") ));
			$rss_item->description = strstr($content_html,"\n");
		}

		$rss_item->subject = $category;

		$rss_item->author = strip_tags($author);

		if ($category!="") $category .= ": ";

		if ($title!="") {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($title)));
		} else {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($rss_item->title)));
		}

		$rss_item->description = trim_br(html_entity_decode($rss_item->description));

		//urls a href
		$rss_item->description = preg_replace_callback('|(<a href=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		//src des img
		$rss_item->description = preg_replace_callback('|(<img src=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		return $rss_item;
	}
	//-----------------------------------------------------------------

	$rss = new UniversalFeedCreator();

	$rss->useCached(XML_FILE,PAGE_CACHE);

	$rss->title       = PAGE_TITLE;
	$rss->description = PAGE_DESC;
	$rss->link        = PAGE_URL;
	$rss->language    = PAGE_LANG;

	$rss->syndicationURL = "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$HTTP_SERVER_VARS['SCRIPT_NAME'];
	$rss->publisher      = "Tanguy Pruvot [mailto:tanguy(at)pruvot(dot)org]";
    $rss->subject        = "Messages";
    $rss->rights         = "Posters";

	$matches = array();

    $category  = "";

	//i=case (i)nsensitive, s=ignorer retours ligne
	if (preg_match_all("|".BLOC_START."(.*?)".BLOC_STOP."|is", $html_data, $table_matches)) {
		$html_data = "";
		foreach($table_matches[1] as $tableitem) {

			$tableitem = html_entity_decode($tableitem);
			$p = strrpos(" - ",$tableitem);
			$author    = strip_tags(substr("<b>",substr($tableitem,0,$p)));
			$fielddata = substr($tableitem,$p,strlen($tableitem)-$p);
			$splitdate = split("<i>",$fielddata);
			$date = $splitdate[1];
			if (ereg("([0-9]+)/([0-9]+)/([0-9]+) ([0-9]+):([0-9]+)",$date,$regdate)) {
			   $date = sprintf("%02d/%02d/%04d",$regdate[2],$regdate[1],$regdate[3]);
			   $time = sprintf("%02d:%02d",$regdate[4],$regdate[5]);
            }
			$date = datefr2ISO8601($date,$time.":00+01:00");
			$title = "";

			$rss_item = cell_content_to_item($tableitem,$date,$category,$title,$author);
			if ($rss_item->link=="") $rss_item->link = $rss->link;
			$rss->addItem($rss_item);

		}
		$rss->saveFeed("RSS1.0",XML_FILE);
	}
	else die(htmlentities("error! no <table></table> matche(s)"));
}
else die("error! no data !");

//

?>