<?php

//---------------------------------------------------
// RSS Parser/Creator v1.3
// Script created 19 Apr 2004 by tanguy at pruvot.org
//---------------------------------------------------

include("inc/browseremulator.class.php");
include("inc/rss_tools.inc.php");
include("inc/ini.class.php");

define("XML_FILE","wdasso.xml");

define("PAGE_TITLE", "WinDevAsso - Nouveauts");
define("PAGE_DESC",  "Derniers ajouts sur http://www.windevasso.org");
define("PAGE_URL",   "http://www.windevasso.org/cgi-bin/gesnou.exe?exec=aff");
define("PAGE_LANG",  "fr");

define("PAGE_START", '<!-- Fin menu haut -->');
define("PAGE_STOP",  '[ <A HREF="gespage.exe?exec=index&IDSESSION=');

define("BLOC_START",'<td valign="top" width="80">');
define("BLOC_STOP",'</tr>');

//---------------------------------------------------------------------

define("PAGE_DIR", substr(PAGE_URL,0,strrpos(PAGE_URL,"/")+1));

$ini_section = substr(XML_FILE,0,strpos(XML_FILE,"."));
IniIncrementValue($ini_section,"ACCESSED","stats.ini");

//#####################################################################
//WGET

$be = new BrowserEmulator();
$be->addHeaderLine("Referer", PAGE_URL);
$be->addHeaderLine("Accept-Encoding", "x-compress; x-zip");

$file = $be->fopen(PAGE_URL);
$response = $be->getLastResponseHeaders();

if (!(strpos($response[0],"200"))) die("error! can't connect to site :".$response[0]);

$html_data = "";
while ($line = fgets($file, 1024)) {
	$html_data .= $line;
}
fclose($file);

//#####################################################################

$html_data = strstr($html_data, PAGE_START);
$html_data = substr($html_data, 0, strlen($html_data)-strlen( strstr($html_data,PAGE_STOP) ));
$html_data = trim_br(str_replace("\n","",$html_data));

if ($html_data) {

	include("inc/feedcreator.class.php");

	//-----------------------------------------------------------------
	function restore_urls($matches,$base_url=PAGE_DIR) {
		return $matches[1].assemble_url($base_url,$matches[2]).$matches[3];
	}

	function cell_content_to_item($content_html, $date="", $category="", $title="", $base_url=PAGE_DIR) {

		$rss_item = new FeedItem();

		$rss_item->date = $date;

		if (preg_match_all('|<a href="([^"]*)"[^>]*>(.*?)(</a>)?|is', $content_html, $sub_matches)) {
			$rss_item->link        = assemble_url($base_url,$sub_matches[1][0]);
			$rss_item->title       = $sub_matches[2][0];
			$rss_item->description = trim($content_html);
		} else {
			$rss_item->title = substr($content_html,0,strlen($content_html)-strlen( strstr($content_html,"\n") ));
			$rss_item->description = trim_br(strstr($content_html,"\n"));
		}

		$rss_item->subject = $category;

		if ($category!="") $category .= ": ";

		if ($title!="") {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($title)));
		} else {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($rss_item->title)));
		}

		$rss_item->description = trim_br(html_entity_decode($rss_item->description));

		//urls a href
		$rss_item->description = preg_replace_callback('|(<a href=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		//src des img
		$rss_item->description = preg_replace_callback('|(<img src=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		//specifique wdasso
		if (ereg("\(([^\)]*)\)",$rss_item->description,$regauth)) $rss_item->author = $regauth[1];

		$rss_item->link = eregi_replace("[\?\&]IDSESSION\=[0-9]+","",$rss_item->link);
		$rss_item->description = str_replace($regauth[0],"",$rss_item->description);
		$rss_item->description = eregi_replace("[\?\&]IDSESSION\=[0-9]+","",$rss_item->description);

        if ($rss_item->description!="")
		 if (strpos("-".$rss_item->title,$rss_item->description)>0)
		   $rss_item->description = "";

        if (eregi("<A HREF",$rss_item->description) && !(eregi("</A>",$rss_item->description)))
           $rss_item->description .= "</a>";

		return $rss_item;
	}
	//-----------------------------------------------------------------

	$rss = new UniversalFeedCreator();

	$rss->useCached(XML_FILE,1800);

	$rss->title       = PAGE_TITLE;
	$rss->description = PAGE_DESC;
	$rss->link        = PAGE_URL;

	$rss->language    = PAGE_LANG;

	$rss->syndicationURL = "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$HTTP_SERVER_VARS['SCRIPT_NAME'];
	$rss->publisher      = "Tanguy Pruvot [mailto:tanguy(at)pruvot(dot)org]";
    $rss->rights         = "Copyright 2004, WindevAsso";

	$matches = array();

	//i=case (i)nsensitive, s=ignorer retours ligne
	$regex = "|".BLOC_START."(.*?)".BLOC_STOP."|is";

	if (preg_match_all($regex, $html_data, $table_matches)) {
		$html_data = "";
		foreach($table_matches[1] as $tableitem) {

			$tableitem = str_replace("> <","><",$tableitem);

			$tableitem = trim_br(strip_tags($tableitem,"<a><br><br />"));

			$elem = split("<br><br>",$tableitem);

			for($L=0;$L<count($elem);$L++) {

				if ($L==0) {
					if (ereg("\[([0-9]+/[0-9]+/[0-9]+)\]",$elem[$L],$regdate)) {
						$date = datefr2ISO8601($regdate[1]);
						$title = str_replace($regdate[0],"",$elem[$L]);
						$elem[$L] = $title;
					}
				} else
					$title = $elem[$L];

				if (strpos("-".$title,"<br>")>0) $title = substr($title,0,strpos($title,"<br>"));

				$title = trim_br(html_entity_decode(strip_tags($title)));

				$category = "";
				//echo html_entity_decode($elem[$L])."~~";
				$elem[$L] = trim_br(html_entity_decode($elem[$L]));
				//$tableitem = strip_tags($tableitem ,"<br><a>" );

				$rss_item = cell_content_to_item($elem[$L],$date,$category,$title);
				if ($rss_item->link=="") $rss_item->link = $rss->link;

				$rss->addItem($rss_item);

			}

		}
		$rss->saveFeed("RSS1.0",XML_FILE);
	}
	else die("error! no BLOC matche(s)");
}
else die("error! no data !");

//

?>