<?php

//---------------------------------------------------
// RSS Parser/Creator
// Script created 19 Apr 2004 by tanguy at pruvot.org
//---------------------------------------------------

include("inc/browseremulator.class.php");
include("inc/rss_tools.inc.php");
include("inc/ini.class.php");

define("XML_FILE","webdev7.xml");

define("PAGE_TITLE", "Webdev 7 - Mises  jour");
define("PAGE_DESC",  "Espace de tlchargement de PC SOFT - Webdev 7 (Fr)");
define("PAGE_URL",   "http://www.pcsoft.fr/st/telec/webdev7/index.html");
define("PAGE_URL2",  "http://www.pcsoft.fr/st/telec/webdev7/indexdep.html");

define("PAGE_LANG",  "fr");

define("PAGE_START", '<!-- #BeginEditable "Contenu" -->');
define("PAGE_STOP",  '<!-- #BeginEditable "PageLongue" -->');

//---------------------------------------------------------------------

define("PAGE_DIR", substr(PAGE_URL,0,strrpos(PAGE_URL,"/")+1));

$ini_section = substr(XML_FILE,0,strpos(XML_FILE,"."));
IniIncrementValue($ini_section,"ACCESSED","stats.ini");

//#####################################################################
//WGET

$be = new BrowserEmulator();
$be->addHeaderLine("Referer", "http://www.pcsoft.fr/st/telec/index.html");
$be->addHeaderLine("Accept-Encoding", "x-compress; x-zip");

$file = $be->fopen(PAGE_URL);
$response = $be->getLastResponseHeaders();

if (!(strpos($response[0],"200"))) die("error! can't connect to site :".$response[0]);

$html_data = "";
while ($line = fgets($file, 1024)) {
	$html_data .= $line;
}
fclose($file);

$html_data = strstr($html_data, PAGE_START);
$html_data = substr($html_data, 0, strlen($html_data)-strlen( strstr($html_data,PAGE_STOP) ));
$html_data = trim_br(str_replace("\n","",$html_data));

if (PAGE_URL2) {
    $file = $be->fopen(PAGE_URL2);
    $response = $be->getLastResponseHeaders();

    if (!(strpos($response[0],"200"))) die("error! can't connect to site :".$response[0]);
    $html_data2="";
    while ($line = fgets($file, 1024)) {
    	$html_data2 .= $line;
    }
    fclose($file);

    $html_data2 = strstr($html_data2, PAGE_START);
    $html_data2 = substr($html_data2, 0, strlen($html_data2)-strlen( strstr($html_data2,PAGE_STOP) ));
    $html_data2 = trim_br(str_replace("\n","",$html_data2));

    $html_data .= $html_data2; $html_data2="";
}

//#####################################################################

if ($html_data) {

	include("inc/feedcreator.class.php");

	//-----------------------------------------------------------------
	function restore_urls($matches,$base_url=PAGE_DIR) {
		return $matches[1].assemble_url($base_url,$matches[2]).$matches[3];
	}

	function cell_content_to_item($content_html, $date="", $category="", $title="", $base_url=PAGE_DIR) {

		$rss_item = new FeedItem();

		$rss_item->date = $date;

		if (preg_match_all('|<a href="([^"]*)"[^>]*>(.*?)</a>(.*)|is', $content_html, $sub_matches)) {
			$rss_item->link        = assemble_url($base_url,$sub_matches[1][0]);
			$rss_item->title       = $sub_matches[2][0];
			$rss_item->description = $sub_matches[3][0];
		} else {
			$rss_item->title = substr($content_html,0,strlen($content_html)-strlen( strstr($content_html,"\n") ));
			$rss_item->description = strstr($content_html,"\n");
		}

		$rss_item->subject = $category;

		if ($category!="") $category .= ": ";

		if ($title!="") {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($title)));
		} else {
			$rss_item->title   = $category.strip_tags(trim_br(html_entity_decode($rss_item->title)));
		}

		$rss_item->description = trim_br(html_entity_decode($rss_item->description));

		//urls a href
		$rss_item->description = preg_replace_callback('|(<a href=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		//src des img
		$rss_item->description = preg_replace_callback('|(<img src=")([^"]*)("[^>]*>)|is',"restore_urls",$rss_item->description);

		return $rss_item;
	}
	//-----------------------------------------------------------------

	$rss = new UniversalFeedCreator();

	$rss->useCached(XML_FILE,1800);

	$rss->title       = PAGE_TITLE;
	$rss->description = PAGE_DESC;
	$rss->link        = PAGE_URL;
	$rss->language    = PAGE_LANG;

	$rss->syndicationURL = "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$HTTP_SERVER_VARS['SCRIPT_NAME'];
	$rss->publisher      = "Tanguy Pruvot [mailto:tanguy(at)pruvot(dot)org]";
    $rss->rights         = "Copyright 2004, PCSoft";

	$matches = array();

	//i=case (i)nsensitive, s=ignorer retours ligne
	if (preg_match_all("|<table.*?</table>|is", $html_data, $table_matches)) {
		$html_data = "";
		foreach($table_matches[0] as $tableitem) {

			if (preg_match_all("|<td[^>]+>(.*?)</td><td[^>]+>(.*?)</td>|is", $tableitem, $td_matches)) {
				for($i=0;$i<count($td_matches[1]);$i++) {
					if ($i==0) {

						//On ignore l'entete de tableau mais on le garde en tq catgorie.
						$table_category = trim_br(strip_tags(html_entity_decode($td_matches[1][$i])));

					} else {

						$item = str_replace("> <","><",$td_matches[1][$i]);

						if (strpos($item,"<br><br>") && preg_match_all("|[0-9]+/[0-9]+/[0-9]+|s",$td_matches[2][$i],$rg_date)) {

							$ln_item = split("<br><br>",$item);

							for($L=0;$L<count($ln_item);$L++) {
                                if ($L<count($rg_date)) $date=$rg_date[$L][0];
								$rss->addItem(cell_content_to_item($ln_item[$L],datefr2ISO8601($date),$table_category));
							}

						} else {
							$rss->addItem(cell_content_to_item($item,datefr2ISO8601($date),$table_category));
						}
					}
				}
			}
			else die(htmlentities("error! no <tr><td></td><td></td> matche(s)"));
		}
		header("Content-type: application/rss+xml");
		$rss->saveFeed("RSS1.0",XML_FILE);
	}
	else die(htmlentities("error! no <table></table> matche(s)"));
}
else die("error! no data !");

//

?>